#ifndef __GRID_H__
#define __GRID_H__
#include "GraphicsLib.h"

class Grid
{
	public :
		// the width of the Grid being displayed (X)
		int Width;
		// the depth of the Grid being displayed (Z)
		int Depth;
		// the number of sub divs in the X direction
		int Xsteps;
		// the number of sub divs in the Z direction
		int Zsteps;
		// Pointer to grid points stored in a single array
		GraphicsLib::Point3 *GridPoints;
		// constructor
		Grid(int W,int H,int Xs,int Zs);
		// destructor
		~Grid();
		// drwa method
		void Draw(void);
};




#endif

