#include "Canvas.h"
#include "Point3.h"
#include "Util.h"
#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
using namespace std;
using namespace GraphicsLib;
/*!
 moves to a new point on the canvas (no Draw)
 \param Real x sets the new x position
 \param Real y sets the new y position
 */
/*! \todo Complete code for Seminar 3 */
void Canvas:: moveTo(Real x, Real y)
{
CP.x=x;
CP.y=y;

}


//draws a line from current point to new point
/*!
 *draws a line from the current point CP to the new point
 *indicated by x,y
 *\param Real x the new x position to draw to
 *\param Real y the new y position to draw to
 */
/*! \todo complete code for seminar 3 */
void Canvas:: lineTo(Real x, Real y)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}

//<<setWindow>>
/*!set the window using open GL passing in the extents of the window
 * \param Real l the left extent of the window
 * \param Real r the right extent of the window
 * \param Real b the bottom extent of the window
 * \param Real t the top extent of the window
 * \todo write code for seminar 3
 */

void Canvas:: setWindow (Real l, Real r, Real b, Real t)
{
window.set(l,r,b,t);
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
gluOrtho2D(l,r,b,t);
}

//<<setViewport>>
/*! set the current viewport passing in the viewports window size
 * \param GLint l the left extent of the window
 * \param GLint r the right extent of the window
 * \param GLint b the bottom extent of the window
 * \param GLint t the top extent of the window
 \todo complete code for seminar 3 */
void Canvas:: setViewport (GLint l, GLint r, GLint b, GLint t)
{
glViewport(l, b, r - l, t- b);
}
/*! 
 *get the current Viewport as an IntRect
 *\return IntRect the viewports extent
 *
 */
IntRect Canvas:: getViewport(void)
{
	return viewport;
}
/*!
 *get the current canvas window
 *\return IntRect the viewports extents
 */
RealRect Canvas:: getWindow(void)
{
	return window;
}
/*! clears the screen 
 *\todo complete code for seminar 3
 * */
void Canvas:: clearScreen(void)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}
/*!sets the background colour
 * \param Real r the red component of the colour
 * \param Real g the green component of the colour
 * \param Real b the blue component of the colour
 * \todo complete code for seminar 3
 */
void Canvas:: setBackgroundColour(Real r, Real g, Real b)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}
/*!sets the backgroun colour
 * \param Colour col the colour to set the bg
 */
void Canvas :: setBackgroundColour(Colour col)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}
/*!sets the current drawing colour
 *\param Real r the red component
 *\param Real g the green component
 *\param Real b the blue component
 * \todo complete code for Seminar 3
 */
void Canvas:: setColour(Real r, Real g, Real b)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}
/*!sets the current drawing colour
 *\param Colour the colour to set the  bg
 */

void Canvas::setColour(Colour col)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;

}

/*!draws a line from the current CP to the point passed in 
 * \param Point2 p the point to draw to
 * \todo complete code for seminar 3
 */

void Canvas:: lineTo(Point2 p)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;
}
/*!constructor for the canvas class, creates a simple 
 * gl window using glut and sets it to the size passed in
 * \param GLint width the width of the window
 * \param GLint height the height of the window
 */
Canvas:: Canvas(GLint width, GLint height)
{
	setWindow(0, (Real)width, 0, (Real)height); // default world window
	setViewport (0, width, 0, height); //default viewport
	CP.set(0.0f, 0.0f); //initialize the cp to (0,0)
}
/*! moves the CP to the point passed in (no draw)
 * \param Point2 p the new point
 * \todo complete code for seminar 3
 */

void Canvas:: moveTo(Point2 p)  //moves current point CP to point p object 
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;
}

/*! get the aspect ratio of the current window
 * \return Real the aspect ratio
 */

Real Canvas:: getWindowAspectRatio(void)  //calculates aspect ratio of world window
{
	Real width, height, aspectRatio;
	width = window.r - window.l;
	height = window.t - window.b;
	aspectRatio = width/height;
	return aspectRatio;
}
/*! moves relative to the current CP (no draw)
 * \param Real dx the ammount to change x by
 * \param Real dy the ammount to change y by
 * \todo complete code for seminar 3
 */
void Canvas:: moveRel(Real dx, Real dy)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;
}
/*! draws relative to current point
 * \param Real dx ammount to draw 
 * \param Real dy ammount to draw
 * \todo complete code for seminar 3 */
void Canvas :: drawRel(Real dx,Real dy)
{
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;	
}
/*! shows the current Point 
 *
 */
void Canvas :: CPshow(void)
{
DrawSquare((Real) CP.x,(Real) CP.y,2);
}
