#include "Light.h"
#include <iostream>
#include <GL/glut.h>
using namespace std;
using namespace GraphicsLib;
Light::Light(GLint number, Point3 Pos, Colour col,LIGHTMODES lightmode)
{
 LightNo=GL_LIGHT0+number;
 pos.set(Pos);
 colour.set(col);
 SpecColour.set(col);
 LightMode=lightmode;


Real colr[4]; // arrays to hold openGL lights: color and position
colour.build4tuple(colr);
Real zero[] = {0.0,0.0,0.0,0.0};
glLightfv(LightNo,GL_DIFFUSE,colr); // tell openGL diffuse light color
glLightfv(LightNo,GL_SPECULAR,colr); // tell openGl specular light color
glLightfv(LightNo,GL_AMBIENT,zero);
}

Light::Light(GLint number, Point3 Pos, Colour col,Colour speccol,LIGHTMODES lightmode)
{
 LightNo=GL_LIGHT0+number;
 pos.set(Pos);
 colour.set(col);
 SpecColour.set(speccol);
 LightMode=lightmode;
 Real colr[4]; // arrays to hold openGL lights: color and position
 colour.build4tuple(colr);
 Real zero[] = {0.0,0.0,0.0,0.0};
 glLightfv(LightNo,GL_DIFFUSE,colr); // tell openGL diffuse light color
 SpecColour.build4tuple(colr);
 glLightfv(LightNo,GL_SPECULAR,colr); // tell openGl specular light color
 glLightfv(LightNo,GL_AMBIENT,zero);
}

void Light::Show(void)
{

/*! \todo write code to draw where the light is in the scene */
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;
}

void Light::Enable()
{
Real colr[4], posn[4]; // arrays to hold openGL lights: color and position
colour.build4tuple(colr);
pos.build4tuple(posn);
posn[3]=LightMode;
posn[3]=LightMode;
cerr <<"Method not Implimented "<<__FILE__<<" "<<__LINE__<<endl;
}

