#include <iostream>
#include "Point2.h"
using namespace std;
using namespace GraphicsLib;
void Point2 :: draw(void)
{
	glVertex2f(x,y);
}

Point2 Point2::operator*(Real rhs)
{
	return Point2 (x*rhs,y*rhs);
}

Point2 Point2::operator/(Real rhs)
{
assert(rhs !=0);
return Point2(x/rhs,y/rhs);
}

Point2 Point2::operator/(Point2 rhs)
{
	assert(rhs.x !=0 && rhs.y !=0 );
	return Point2(x/rhs.x,y/rhs.y);
}

ostream& GraphicsLib::operator<<(ostream& output, const Point2 & s)
{
    return output<<"["<<s.x<<","<<s.y<<"]";
}

istream& GraphicsLib::operator>>(std::istream& input, Point2 &s)
{
return input >> s.x >> s.y;

}



