#ifndef SCREEN_H_INCLUDED
#define SCREEN_H_INCLUDED

#include "GraphicsLib.h"
using namespace std;
using namespace GraphicsLib;

	extern int WIN_HEIGHT;

class screen {
    public:
	float aspectRatio; // width(x) / height (y)
	Vector size; //the width and height in GUs of the global Map

	screen();
	screen(float width, float height);
	Vector convToGL(Vector GUunits);
	float convToGL(float GUunit);
	void GUToGLvertex(float mapCoordX, float mapCoordY);
	Vector convToGU(int PixelCoordX, int PixelCoordY);
	void draw();
};

class visibleArea : public screen {

    private:
	Vector bottomLeft;
    public:
    	visibleArea(float width, float height, float bottomLeftX, float bottomLeftY);
	Vector convToGL(Vector GUunits);
	void set(float width, float height, float bottomLeftX, float bottomLeftY);
};

#endif
