#ifndef _RNG_H_
#define _RNG_H_

// ------------------------------
// Filename      : rng.h
// Author        : Sven Maerivoet
// Last modified : 05/05/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------
#include <math.h>
// useful type defintion
namespace GraphicsLib {



class RNG {
  public:
    // constructor
    RNG(void);

    // destructor
    ~RNG(void);

    // methods
    static void setSeed(unsigned long int seed);
    static void setSeedWithTime(void);
    static int uniformInt(void);
    static double uniform(void);

  private:
    // data-members
    static double fX[5];
};
}
#endif

