#include "Fog.h"

using namespace GraphicsLib;

Fog::Fog(GLenum type,Real near, Real far,Real density,Colour col)
{
fogtype=type;
Near=near;
Far=far;
Density=density;
FogColour=col;
glFogi(GL_FOG_MODE,type);
glFogf(GL_FOG_START,near);
glFogf(GL_FOG_START,far);
glFogf(GL_FOG_DENSITY,density);
Real c[4];
col.build4tuple(c);
glFogfv(GL_FOG_COLOR,c);
}

void Fog::Enable()
{
glEnable(GL_FOG);
glEnable(GL_DEPTH_TEST);

}
void Fog::Disable()
{
glDisable(GL_FOG);
}
void Fog::ChangeMode(GLenum ftype)
{
fogtype=ftype;
glFogi(GL_FOG_MODE,ftype);
}
 
 
