
#include "botgrpclass.h"

using namespace std;
using namespace GraphicsLib;


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//bot group methods

botGrp::botGrp() {
	cout << "\n\n..........new Group.........." << endl;
	pBotList.clear();
	numBots = 0;
}

void botGrp::addBot(bot* pWhatBot) {

	pWhatBot->grpID = numBots;

	cout << " Adding bot["<< pWhatBot->universeID << "] to group["
		<< pWhatBot->pBotGrp->universeID << "]  address: " << pWhatBot << endl;
	pBotList.push_back(pWhatBot);
	numBots++;
	printGrp();
}

void botGrp::placeBots(Vector placeWhere) {
	// TODO to be implemented, but should use the ai to move all the bots towards the start point
	// whilst avoiding collision and keeping a distance. need to be randomly placed around the map to start with

	//simply place them in a long line from the startPos
	Vector tempForward(0,1,0);
	Vector tempVel(0,0,0);
	Vector tempPos = placeWhere;
	cout << "Arranging Group[" << universeID << "] around "<< placeWhere << " numBots:"<< numBots << " typeRadius:" << pBotList[0]->pBotType->radius << endl;
	for (int i=0; i<numBots; i++) {
		cout << "  > Bot[" << pBotList[i]->universeID << "] >>>   ";
		pBotList[i]->set(tempForward, tempVel, tempPos);
		tempPos.x += pBotList[i]->pBotType->radius*3;
	}
}

void botGrp::printGrp(){

cout << "Grp[" << universeID << "] botList:" << endl;
	for (int i=0; i<numBots; i++) {
		cout << "  >Bot[" << pBotList[i]->universeID << "]   pos:"<< pTheUniverse->botList[pBotList[i]->universeID].position
			<< "    grpAddr["<< i <<"]:" << pBotList[i] << "     universeAddr["<< pBotList[i]->universeID <<"]:"<< &(pTheUniverse->botList[pBotList[i]->universeID]) <<endl;


	}

}

void botGrp::deleteBot(int whatID) {

	cout << "Removing Bot["<< pBotList[whatID]->universeID <<"] from group["<< universeID << "] (bot grpID:"<< whatID <<")" << endl;
	pBotList.erase(pBotList.begin() + whatID);
	numBots--;

	for (int i=whatID; i<numBots; i++) {
		pBotList[i]->grpID --;
	}
}
