//botgrpclass.h
#ifndef BOTGRPCLASS_H_INCLUDED
#define BOTGRPCLASS_H_INCLUDED

#include <vector>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"


#include "botclass.h"

using namespace std;
using namespace GraphicsLib;

// all the classes that it will see in this file
class universe;
class botGrp;
class bot;


//bot group class
class botGrp {

    public:
	int universeID;
	universe *pTheUniverse;

	vector <bot*> pBotList;
	int numBots;

	Vector startPos;  //also need waypoint list
	Colour grpColour;

     //methods >>>>>>>>>>>>>>>

	botGrp();
	void addBot(bot* pWhatBot);

	void placeBots(Vector placeWhere);

	void printGrp();

	void deleteBot(int whatID);
};

#endif
