#include "path.h"

void path::addPointFront(float x, float y) {
	Vector tempVec(x,y,0);
	pointList.insert(pointList.begin(),tempVec);
}
void path::addPointBack(float x, float y) {
	Vector tempVec(x,y,0);
	pointList.insert(pointList.end(),tempVec);
}

void path::draw() {
Vector tempVec;
    glBegin(GL_LINE_STRIP);
	for (int i=0; i<pointList.size(); i++) {
		tempVec = pTheUniverse->globalMap.convToGL(pointList[i]);
		glVertex3f(tempVec.x, tempVec.y, tempVec.z);
	}
    glEnd();
	for (int i=0; i<pointList.size(); i++) {
		glPushMatrix();
			tempVec = pTheUniverse->globalMap.convToGL(pointList[i]);
			glTranslatef(tempVec.x,tempVec.y,tempVec.z);
			glutSolidSphere(0.01, 10, 2);
  		glPopMatrix();
	}
}

void path::printPath() {
	for (int i=0; i<pointList.size(); i++) {
		cout << "path point[" << i << "] - " << pointList[i] << endl;
	}
}