//timer.h
#ifndef TIMER_H_INCLUDED
#define TIMER_H_INCLUDED

#include "GraphicsLib.h"
#include <time.h>

using namespace std;
using namespace GraphicsLib;


class Timer {

  public:
	bool active; // true timer is counting, false not counting

	double prevTime; //in clock ticks

	float duration; // how long the timers been going in seconds
	float interval; //seconds between updates

	Timer(bool active_in = false); //constructor - normally start with the timer turned off

	double getTimeOfDay();
	void start();
	void pause();
	void stop();
	void update();

	float fps() { return (1/interval); }
};

#endif
